#include <cstdio>
#include <cstring>
#include <algorithm>
#include <stack>
#include <vector>
#include <cassert>

using namespace std;

#define REP(i,n) for(int i=0; i<n; ++i)
#define PB push_back

typedef long long LL;

int x[10], P[10];

int nwd(int a, int b){
	if(b == 0) return a;
	return nwd(b, a%b);
}
int nww(int a, int b){
	return (a/nwd(a,b)) * b;
}

struct Q{
	int l, m;
	
	void simply(){
		if(m < 0){ m = -m; l = -l; }
		int d = nwd(abs(l), abs(m));
		m /= d;
		l /= d;
	}

	Q(int _l = 0, int _m = 1) : l(_l), m(_m) {
		simply();
	}
	
	void add(Q x){
		int nw = nww(m, x.m);
		l *= nw/m;
		m = nw;
		l += (nw / x.m) * x.l;
		simply();
	}
	
	void print(){
		printf("%d/%d\n", l, m);
	}
};

Q a[10];

int main()
{
	while(true){
		int n;
		scanf("%d", &n);
		if(n == 0) break;
		REP(i,n) scanf("%d%d", &x[i], &P[i]);
		if(n == 1){
			printf("POP\nNUM %d\nEND\n\n", P[0]);
			continue;
		}
		REP(i,n+1) a[i] = Q();
		REP(i,n){
			int tab[10];
			REP(j,10) tab[j] = 0;
			tab[0] = 1;
			int M = 1;
			REP(j,n){
				if(i == j) continue;
				M *= (x[i] - x[j]);
				
				for(int t=n-1; t>0; --t){
					tab[t] = tab[t-1] - x[j] * tab[t];
				}
				tab[0] *= -x[j];
			}
			REP(it,n){
				a[it].add(Q(tab[it] * P[i], M));
			}
		}
		
		//REP(i,n) a[i].print();
		int NWW = 1;
		REP(i,n) NWW = nww(NWW, a[i].m);
		REP(i,n) a[i].l *= (NWW/a[i].m);
		REP(i,n-2) printf("DUP\n");
		printf("NUM 0\n");
		for(int i=n-1; i>=0; --i){
			if(a[i].l > 0){
				printf("NUM %d\nADD\n", a[i].l);
			}
			else{
				printf("NUM %d\nSUB\n", -a[i].l);
			}
			if(i > 0) printf("MUL\n");
		}
		printf("NUM %d\nDIV\n", NWW);
		
		printf("END\n\n");
	}
	return 0;
}
