#include <cstdio>

int dx[]= {0,0, 1, -1};
int dy[]={1,-1,0,0};

int N, M;
char c[102][102];

bool ins(int a,int b) {
	return a>=0 && a < N && b >=0 && b < M;
}

char d[102][102];

int pa = 0;
int ne = 0;

void count(int a, int b) {
	int res = 0;
	
	d[a][b] = 'X';
	if ((a+b) % 2 == 0) pa++;
	else ne++;
	
	for(int i=0; i<4; i++) {
		int x = a + dx[i];
		int y = b + dy[i];
		if (ins(x, y) && d[x][y] == '.') {
			count(x, y);
		}
	}
}

void put_in_res(int a,int b,int resp, int resn) {
	c[a][b] = 'X';
	if ((a+b) % 2 == 0) c[a][b] = resp;
	else c[a][b] = resn;
	
	for(int i=0; i<4; i++) {
		int x = a + dx[i];
		int y = b + dy[i];
		if (ins(x, y) && c[x][y] == '.') {
			put_in_res(x, y, resp, resn);
		}
	}
}

int main() {
	while(true) {
		scanf("%d %d",&N, &M);
		if (N == 0 ) return 0;
		for(int i=0; i<N; i++) {
			scanf("%s", c[i]);
			for(int j=0; j<M; j++) {
				d[i][j] = c[i][j];
				res[i][j] = 0;
			}
		}
		
		for(int i=0; i<N; i++) {
			for(int j=0; j<M; j++) {
				ne = pe = 0;
				if (c[i][j] == 'X') res[i][j] = 'X';
				if (res[i][j] != 0) {
					if (pa == ne) { put_in_res(i, j, 'A', 'A'); }
					else { put_in_res(i, j, pa > ne ? 'B' : 'A', pa > ne ? 'A' : 'B'); }
			}
		}
		
		for(int i=0; i<N; i++) {
			for(int j=0; j<M; j++) {
				putchar(res[i][j]);
			}
			puts("");
		}
		puts("");
	}
	
	return 0;
}
